---
title: Adding APIs to the navigator object
slug: Mozilla/Developer_guide/Adding_APIs_to_the_navigator_object
tags:
  - DOM
  - Developing Mozilla
  - NeedsTechnicalReview
---
<p>{{ gecko_minversion_header("9.0") }}</p>

<p>Starting with Gecko 9.0 {{ geckoRelease("9.0") }}, you can easily add new APIs to the {{ domxref("window.navigator") }} object by using the Category Manager. Add an entry to the "JavaScript-navigator-property" category.</p>

<p>The object must be implemented as an XPCOM component. Each method below of adding new objects to the navigator object requires that the new object is a registered XPCOM component. You can read about <a href="/en-US/Add-ons/Code_snippets/JS_XPCOM#Implementing_XPCOM_components_in_JavaScript">creating and registering XPCOM components in JavaScript</a>.</p>

<h2 id="Programmatically_adding_an_object_to_navigator">Programmatically adding an object to navigator</h2>

<pre>var categoryManager = Components.classes["@mozilla.org/categorymanager;1"]
                      .getService(Components.interfaces.nsICategoryManager);

categoryManager.addCategoryEntry("JavaScript-navigator-property", "myApi",
                      MY_CONTRACT_ID, false, true);
</pre>

<p>This adds a new object, <code>myApi</code>, to the {{ domxref("window.navigator") }} object. The newly added object is a reference to the component specified by the contract ID <code>MY_CONTRACT_ID</code>. You can learn more about Contract IDs are unique text identifiers for XPCOM components.</p>

<h2 id="Using_a_manifest_to_add_an_object_to_navigator">Using a manifest to add an object to navigator</h2>

<p>You can also add an object to the {{ domxref("window.navigator") }} object by using the <a href="/en-US/docs/Chrome_Registration">chrome manifest</a> of an add-on:</p>

<pre>component {ffffffff-ffff-ffff-ffff-ffffffffffff} MyComponent.js
contract @mozilla.org/mycomponent;1 {ffffffff-ffff-ffff-ffff-ffffffffffff}
category JavaScript-navigator-property myComponent @mozilla.org/mycomponent;1
</pre>

<p>Generate a GUID and replace the "ffff" sections in both the component and contract lines with your GUID.</p>

<p>This adds a new API, <code>myComponent</code>, to the navigator object, which you can then access as <code>navigator.myComponent</code>.</p>

<h2 id="Real-world_example">Real-world example</h2>

<p>You can see an example of how this is used in Firefox by taking a look at how the <code>mozApps</code> API is implemented:</p>

<ul>
 <li>{{ source("dom/apps/Webapps.manifest") }}</li>
 <li>{{ source("dom/apps/Webapps.js") }}</li>
</ul>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{ interface("nsICategoryManager") }}</li>
</ul>
